import smile.*;

public class HeparExample {
    HeparExample() {
        Network net = new Network();
        net.readFile("hepar.xdsl");
        DiagNetwork diagNetwork = new DiagNetwork(net);
        System.out.println(diagNetwork.getPursuedFault());
        DiagResults results = diagNetwork.update();
        for (FaultInfo fault : results.faults) {
            System.out.printf("Index: %d; Pursued: %s; Node: %d; Outcome: %d; Probability: %f\n",
                    fault.index, fault.isPursued ? "pursued" : "not pursued", fault.node, fault.outcome, fault.probability);
        }
        for (ObservationInfo observation : results.observations) {
            System.out.printf("Node: %d; Cost: %f; Entropy: %f; InfoGain: %f\n", observation.node, observation.cost, observation.entropy, observation.infoGain);
            if (observation.observationPriors != null) {
                System.out.print("ObservationPriors: [ ");
                for (double observationPrior : observation.observationPriors) {
                    System.out.printf("%f ", observationPrior);
                }
                System.out.println(" ]");
            }
            if (observation.faultPosteriors != null) {
                System.out.print("FaultPosteriors: [ ");
                for (double faultPosterior : observation.faultPosteriors) {
                    System.out.printf("%f ", faultPosterior);
                }
                System.out.println(" ]");
            }

        }
    }
}
