import smile.*;

public class LocalExample {
    LocalExample() {
        Network net = new Network();
        net.addNode(Network.NodeType.CPT, "Node1");
        net.setNodeDefinition("Node1", new double[]{ 0.2, 0.8 });
        net.addNode(Network.NodeType.CPT, "Node2");
        net.setNodeDefinition("Node1", new double[]{ 0.001, 0.999 });
        net.addNode(Network.NodeType.CPT, "Node3");
        net.addArc("Node1", "Node3");
        net.addArc("Node2", "Node3");
        net.setNodeDefinition("Node3", new double[]{0.1, 0.9, 0.9999, 0.0001, 1.0, 0.0, 0.5, 0.5});
        net.setNodeDiagType("Node1", Network.NodeDiagType.OBSERVATION);
        net.setNodeDiagType("Node2", Network.NodeDiagType.OBSERVATION);
        net.setNodeDiagType("Node3", Network.NodeDiagType.FAULT);
        net.setFaultOutcome("Node3", 0, true);
        DiagNetwork diagNetwork = new DiagNetwork(net);
        System.out.println(diagNetwork.getPursuedFault());
        DiagResults results = diagNetwork.update();
        for (FaultInfo fault : results.faults) {
            System.out.printf("Index: %d; Pursued: %s; Node: %d; Outcome: %d; Probability: %f\n",
                    fault.index, fault.isPursued ? "pursued" : "not pursued", fault.node, fault.outcome, fault.probability);
        }
        for (ObservationInfo observation : results.observations) {
            System.out.printf("Node: %d; Cost: %f; Entropy: %f; InfoGain: %f\n", observation.node, observation.cost, observation.entropy, observation.infoGain);
            if (observation.observationPriors != null) {
                System.out.print("ObservationPriors: [ ");
                for (double observationPrior : observation.observationPriors) {
                    System.out.printf("%f ", observationPrior);
                }
                System.out.println(" ]");
            }
            if (observation.faultPosteriors != null) {
                System.out.print("FaultPosteriors: [ ");
                for (double faultPosterior : observation.faultPosteriors) {
                    System.out.printf("%f ", faultPosterior);
                }
                System.out.println(" ]");
            }
        }
    }
}
